{
===============================================================================

 skMHLos.pas - part of skMHL Library by sergey korowkin (2:6033/27@fidonet),
               port to *nix based OS by Andrew V. Sichevoi (2:6028/9@fidonet)

 Unit for correct work skMHL Library under *nix based OS.
 Version : v0.1beta24-avs
 License : GNU GPL v2.0
 Compiler: FreePascal Compiler v1.0.10
 Author  : Andrew V. Sichevoi
 
===============================================================================
}

Unit skMHLos;

 INTERFACE

Const
     {$IFDEF LINUX}
       {$DEFINE NIX}
     {$ENDIF}
     {$IFDEF FREEBSD}
       {$DEFINE NIX}
     {$ENDIF}
     {$IFDEF NETBSD}
       {$DEFINE NIX}
     {$ENDIF}
     {$IFDEF OPENBSD}
       {$DEFINE NIX}
     {$ENDIF}     
    
     {$IFDEF NIX}
      Mask   = '*';
      Slash  = '/';
      ExtMSG = '.msg';
     {$ELSE}
      Mask   = '*.*';
      Slash  = '\'  ;
      ExtMSG = '.MSG';
     {$ENDIF}
     
 Function ParsePath(sPath : String) : String;     
      
 IMPLEMENTATION
 
{$IFDEF NIX}
 Uses 
     Dos;
{$ENDIF} 
 
{===========================================================================}
Function GetCurrentDir : String;   
Var
   S : String;
   I : Byte;
Begin

 S:=ParamStr(0);
 For I:=Length(S) Downto 1 Do 
  If (S[I] = Slash) Then Begin
   S:=Copy(S, 1, I-1);
   Break;
  End;
  
 GetCurrentDir:=S;
 
End;    
{===========================================================================}
Function ParsePath(sPath : String) : String; 
Begin

{$IFDEF NIX}
 If ((sPath[1] = '~') And (sPath[2] = Slash)) Then Begin
  Delete(sPath, 1, 2);
  sPath:=GetEnv('HOME')+Slash+sPath;
 End;
 If ((sPath[1] = '.') And (sPath[2] = Slash)) Then Begin
  Delete(sPath, 1, 2);
  sPath:=GetCurrentDir+Slash+sPath;
 End;
{$ENDIF}

 ParsePath:=sPath;
 
End; 
{===========================================================================}
 
 
End. 
